/****************************************************************************
** $Id:  cmds/cmdarray.h
** AutoQ3D a qt 3d model editor program
**
** Copyright (C) 2005 -Gonzalo Reynaga Garca. <gonzaloreynaga@yahoo.com>
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public Licence
** as published by the Free Software Foundation; either version 2 
** of the License, or (at your option) any later option.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
** 
*****************************************************************************/


#ifndef CMDARRAY_H
#define CMDARRAY_H
#include "cmds.h"


void cmds::cmdarray(){
	int i,j,k;
	float incf;
	float currangle;
	float angle;
	float segments;
	double var[3];
	d3line *DLV;
	d3triangle *DTV;
	DLV=DataLV->data();
	DTV=DataTV->data();
	if((SecCmd=="**Cancel**")&&!PopViewMode){
			SendText(SecCmd);
			CmdCancel();
			return;
	}

	switch(step){
		
		case 0:
				SendText("--Array--");instruction="Array Angle<360>:";emit instru(instruction);
				tempdataI[0]=0;tempdataF[0]=360.0;tempdataF[1]=8.0;tempdataF[2]=0;tempdataF[3]=1;tempdataF[4]=0;tempdataI[1]=2;
				rtlines->v[0]=0;GriPoint->v[0]=0;rtlines->v[1]=0;GriPoint->v[1]=0;rtlines->v[2]=0;GriPoint->v[2]=0;
				rtcolor[0]=currentcolor[0];rtcolor[1]=currentcolor[1];rtcolor[2]=currentcolor[2];
				rtlines[0].find=1;
				step++;
				return;
		break;
		
		case 1:
			if(CmdSelectPopView()){return;}
			if(CmdCheckSnap()){return;}
			
			if(!SecCmd.compare("")){
				step++;
				instruction=QString("Array Segments [Angle<%1>/BasePoint]:<%2>").arg(tempdataF[0]).arg(tempdataF[1]);emit instru(instruction);
				return;
			}
			if(!SecCmd.compare("setCmdData")){
				if(currentdata.format==2){
					tempdataF[0]=currentdata.v[0];
				instruction=QString("Array Segments [Angle<%1>/BasePoint]:<%2>").arg(tempdataF[0]).arg(tempdataF[1]);emit instru(instruction);
					step++;
					return;
				}
			}
			
		break;
		case 2:
			if(!SecCmd.compare("a")||!SecCmd.compare("A")){
				instruction=QString("Array Angle<%1>:").arg(tempdataF[0]);emit instru(instruction);
				step=1;
				return;
			}
			if(!SecCmd.compare("b")||!SecCmd.compare("B")){
				SendText("Base point");emit instru("Array (Base point):");
				rtlines[0].find=0;
				emit SetMouseMode(MOUSEMODE_PICKPOINT);
				step=3;
				return;
			}
			if(!SecCmd.compare("setCmdData")){
				if(currentdata.format==2){
					tempdataF[1]=currentdata.v[0];
					instruction=QString("Array Segments [Angle<%1>]:<%2>").arg(tempdataF[0]).arg(tempdataF[1]);emit instru(instruction);
					SecCmd="";
				}
			}
			if(!SecCmd.compare("")){

				segments=tempdataF[1];
				angle=tempdataF[0];
				
				for(incf=1.0;incf<segments;incf=incf+1.0){
					currangle=angle*incf/segments;
					var[0]=cosf(currangle*M_PI/180.0);var[1]=sinf(currangle*M_PI/180.0);
					var[2]=1;

				if(var[2]){
				
					for(i=0;i<DataSV.size();i++){
						if(DataSV[i].type==1){
							j=DataLV->size();DataLV->resize(j+1);DLV=DataLV->data();k=DataSV[i].index;
							tempdataF[0]=DLV[k].v1[0]-GriPoint->v[0];
							tempdataF[1]=DLV[k].v1[1]-GriPoint->v[1];
							tempdataF[2]=DLV[k].v1[2]-GriPoint->v[2];
							DLV[j].v1[0]=GriPoint->v[0]+(tempdataF[0]*var[0]-tempdataF[1]*var[1])/var[2];
							DLV[j].v1[1]=GriPoint->v[1]+(tempdataF[1]*var[0]+tempdataF[0]*var[1])/var[2];
							DLV[j].v1[2]=tempdataF[2];
							DLV[j].c1[0]=DLV[k].c1[0];DLV[j].c1[1]=DLV[k].c1[1];DLV[j].c1[2]=DLV[k].c1[2];

							tempdataF[0]=DLV[k].v2[0]-GriPoint->v[0];
							tempdataF[1]=DLV[k].v2[1]-GriPoint->v[1];
							tempdataF[2]=DLV[k].v2[2]-GriPoint->v[2];
							DLV[j].v2[0]=GriPoint->v[0]+(tempdataF[0]*var[0]-tempdataF[1]*var[1])/var[2];
							DLV[j].v2[1]=GriPoint->v[1]+(tempdataF[1]*var[0]+tempdataF[0]*var[1])/var[2];
							DLV[j].v2[2]=tempdataF[2];
							DLV[j].c2[0]=DLV[k].c2[0];DLV[j].c2[1]=DLV[k].c2[1];DLV[j].c2[2]=DLV[k].c2[2];
						}
						
						if(DataSV[i].type==2){
							j=DataTV->size();DataTV->resize(j+1);DTV=DataTV->data();k=DataSV[i].index;
							tempdataF[0]=DTV[k].v1[0]-GriPoint->v[0];
							tempdataF[1]=DTV[k].v1[1]-GriPoint->v[1];
							tempdataF[2]=DTV[k].v1[2]-GriPoint->v[2];
							DTV[j].v1[0]=GriPoint->v[0]+(tempdataF[0]*var[0]-tempdataF[1]*var[1])/var[2];
							DTV[j].v1[1]=GriPoint->v[1]+(tempdataF[1]*var[0]+tempdataF[0]*var[1])/var[2];
							DTV[j].v1[2]=tempdataF[2];
							tempdataF[0]=DTV[k].v2[0]-GriPoint->v[0];
							tempdataF[1]=DTV[k].v2[1]-GriPoint->v[1];
							tempdataF[2]=DTV[k].v2[2]-GriPoint->v[2];
							DTV[j].v2[0]=GriPoint->v[0]+(tempdataF[0]*var[0]-tempdataF[1]*var[1])/var[2];
							DTV[j].v2[1]=GriPoint->v[1]+(tempdataF[1]*var[0]+tempdataF[0]*var[1])/var[2];
							DTV[j].v2[2]=tempdataF[2];
							tempdataF[0]=DTV[k].v3[0]-GriPoint->v[0];
							tempdataF[1]=DTV[k].v3[1]-GriPoint->v[1];
							tempdataF[2]=DTV[k].v3[2]-GriPoint->v[2];
							DTV[j].v3[0]=GriPoint->v[0]+(tempdataF[0]*var[0]-tempdataF[1]*var[1])/var[2];
							DTV[j].v3[1]=GriPoint->v[1]+(tempdataF[1]*var[0]+tempdataF[0]*var[1])/var[2];
							DTV[j].v3[2]=tempdataF[2];
							tempdataF[0]=DTV[k].n1[0];tempdataF[1]=DTV[k].n1[1];tempdataF[2]=DTV[k].n1[2];
							DTV[j].n1[0]=(tempdataF[0]*var[0]-tempdataF[1]*var[1])/var[2];
							DTV[j].n1[1]=(tempdataF[1]*var[0]+tempdataF[0]*var[1])/var[2];
							DTV[j].n1[2]=tempdataF[2];
							tempdataF[0]=DTV[k].n2[0];tempdataF[1]=DTV[k].n2[1];tempdataF[2]=DTV[k].n2[2];
							DTV[j].n2[0]=(tempdataF[0]*var[0]-tempdataF[1]*var[1])/var[2];
							DTV[j].n2[1]=(tempdataF[1]*var[0]+tempdataF[0]*var[1])/var[2];
							DTV[j].n2[2]=tempdataF[2];
							tempdataF[0]=DTV[k].n3[0];tempdataF[1]=DTV[k].n3[1];tempdataF[2]=DTV[k].n3[2];
							DTV[j].n3[0]=(tempdataF[0]*var[0]-tempdataF[1]*var[1])/var[2];
							DTV[j].n3[1]=(tempdataF[1]*var[0]+tempdataF[0]*var[1])/var[2];
							DTV[j].n3[2]=tempdataF[2];
							DTV[j].texture=DTV[k].texture;
							DTV[j].t1[0]=DTV[k].t1[0];DTV[j].t1[1]=DTV[k].t1[1];
							DTV[j].t2[0]=DTV[k].t2[0];DTV[j].t2[1]=DTV[k].t2[1];
							DTV[j].t3[0]=DTV[k].t3[0];DTV[j].t3[1]=DTV[k].t3[1];
							DTV[j].c1[0]=DTV[k].c1[0];DTV[j].c1[1]=DTV[k].c1[1];DTV[j].c1[2]=DTV[k].c1[2];
							DTV[j].c2[0]=DTV[k].c2[0];DTV[j].c2[1]=DTV[k].c2[1];DTV[j].c2[2]=DTV[k].c2[2];
							DTV[j].c3[0]=DTV[k].c3[0];DTV[j].c3[1]=DTV[k].c3[1];DTV[j].c3[2]=DTV[k].c3[2];
						
						}

					}

				}
			}
			CmdCancel();
			return;
			
			}
			
		break;
		case 3: /*SET BASE POINT STATE*/
			if(CmdSelectPopView()){return;}
			if(CmdCheckSnap()){return;}
			
			if(!SecCmd.compare("setCmdData")){
				if(currentdata.format>1){
						SendText("Data reject");
						return;
				}
				if(currentdata.format==0){
					GriPoint->v[0]=currentdata.v[0];GriPoint->v[1]=currentdata.v[1];GriPoint->v[2]=currentdata.v[2];
				}
				if(currentdata.format==1){
					GriPoint->v[0]+=currentdata.v[0];GriPoint->v[1]+=currentdata.v[1];GriPoint->v[2]+=currentdata.v[2];
				}
				var[0]=1;var[1]=0;var[2]=sqrt(var[0]*var[0]+var[1]*var[1]);
				if(var[2]){
				
				rtlines->v[0]=GriPoint->v[0];rtlines->v[1]=GriPoint->v[1];rtlines->v[2]=0;
				rtcolor[0]=currentcolor[0];rtcolor[1]=currentcolor[1];rtcolor[2]=currentcolor[2];rtlines[0].find=1;
				}
			emit instru(instruction);
			step=2;
			emit SetMouseMode(MOUSEMODE_SELECT);
			return;
			}
		break;
	}
	
	SendText(SecCmd);
	SendText("**Secondary Command not found**");
}


#endif


